/*
**	kacode1.c has compiler phase routines
**	kacode2.c has execution phase routines
*/
/*
**  items that handle code generated by statements are
**  named x????? where ????? is the statement (keyword)
**  or abbreviation
*/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
/**/
#include    "kawkdefs.h"
/**/
#include	"ksysprot.h"
#include	"kawkfunc.h"
/**/
/**/
INST    *
retrcode()
{
    return(prx);
}
INST    *
setcode(nu)         /* INITIALIZE PRX CODE POINTER */
NOSIGN	nu;
{
	auto	NOSIGN	nx;
	auto	NOSIGN	try = ZERO;
	if(nu)	{
		prg = prx = pru = (INST *) free_if( (char *) prg);
		while(1)	{
			nx = nu * sizeof(INST);
			prg = (INST *) malloc( nx );
			if(prg == (INST *) NULL)	nu -= BUFSIZ;
			else						break;
			try += 1;
			}
		if(try)	{
			errmsg("setcode <code side reduced> %u cells\n",nu);
			sleep(5);
			}
		prx = prg;
		pru = prg + nu;
		}
    return(prx = prg);
}
INST	*
symcode(ip,is)		/* add symbol to code */
INST	ip;
char	*is;
{
	return(addcode(ip,is));
}
INST    *
addcode(ip,is)      /* ADD ONE INSTRUCTION TO CODE */
INST    ip;         /* INSTRUCTION */
char    *is;        /* INSTRUCTION NAME */
{
/**/
	auto	INST	*lsx = prx;
/**/
    if(prx >= pru)   {
		errmsg("addcode <large program>\n");
        terror(FUBAR);
        }
#ifdef	DEBUG
	fprintf(stderr,"addcode(%lu,%s) prx(%u)\n",ip,is,prx);
#endif
    *prx++ = ip;
#ifdef	DEBUG
	showcode(lsx);
#endif
/* RETURN ORIGINAL POINTER */
    return(lsx);
}
