#define		DEBUG
#undef		DEBUG
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
/**/
#include	"ksysprot.h"
#include	"kawkfunc.h"
/**/
/*EXTERNAL*/
/*STATIC*/
/**/
DATUM   *
esretr()            /* return current stack address */
{
    return(esx);
}
DATUM   *
esetr(ds)           /* set stack pointer */
DATUM   *ds;
{
	esu = es + MAXSTACK - 1;
    if(ds == NULL)  return(esx = es);
    if(ds < es || ds >= esu)    {
/*###kastack.c(25) : warning 16: `errmsg' : no function return type???*/
        errmsg("esetr <invalid stack set> %u %u %u\n",
            es,ds,esu);
        terror(FUBAR);
        return(NULL);
        }
    return(esx = ds);
}
DATUM   *
ipush(dx)		/* push integer */
DATUM	dx;
{
	dx.vtype = VINT;
	return(epush(dx));
}
DATUM   *
dpush(dx)		/* push double */
DATUM	dx;
{
	dx.vtype = VDOUBLE;
	return(epush(dx));
}
DATUM   *
spush(dx)		/* push string */
DATUM	dx;
{
	dx.vtype = VSTRING;
	return(epush(dx));
}
DATUM   *
epush(dx)       /* push datum to stack */
DATUM   dx;
{
#ifdef	DEBUG
	{
	fprintf(stderr,"epush(%u) ",esx);
	switch(dx.vtype)	{
		case	'c':	fprintf(stderr,"%c %o",dx.vtype,dx.v.ivalu);
		when	'd':	fprintf(stderr,"%c %d",dx.vtype,dx.v.dvalu);
		when	'i':	fprintf(stderr,"%c %d",dx.vtype,dx.v.ivalu);
		when	's':	fprintf(stderr,"%c %s",dx.vtype,dx.v.ptr);
						break;
		default:		fprintf(stderr,"?");
		}
	fprintf(stderr,"\n");
	}
#endif
    if(esx >= esu)  {
        errmsg("epush <stack overflow> %u >= %u\n",esx,esu);
        terror(FUBAR);
        return((DATUM *)0);
        }
    *esx++ = dx;
    return(esx);
}
DATUM
epop()          /* pop datum to stack */
{
    if(esx <= es)   {
        errmsg("epop <stack underflow> %u <= %u\n",esx,es);
        terror(FUBAR);
        }
    ds = *--esx;
    return(ds);
}
