#define		DEBUG
#undef		DEBUG
#define		LOCKING
#define		USEFORK
#ifdef		__MSDOS__
#undef		LOCKING
#endif		/*__MSDOS__*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include	"kedfuncs.h"
/**/
/*EXTERN*/
/**/
void
kedrec(is)		/* "X" : read in a recovery buffer */
char	*is;
{
	auto	char	ws[FNMSIZ];
	auto	int	ck = YES;
/**/
	if(*is == 'X')	++is;
	if(*is == '!')	{
		ck = NO;
		is += 1;
	}
/**/
	if(ck && cdx.chg)	{
		errmsg("kedrec <unwritten changes>\n");
		terror(FUBAR);
	}
/**/
	if(isnull(is))	{
		errmsg("kedrec <no file name>\n");
		terror(FUBAR);
	}
	{
	auto	char	*file = fexpand(is);
	strcpy(ws,file);
	file = free_if(file);
	}
/**/
	orphans('u',"kedrec",NULL);
	clredit();
/**/
	doreco(ws);
/**/
	return;
}
void
kedexit(is)			/* "x" : exit, saving buffer */
char	*is;
{
	static	char	*here = "kedexit";
	auto	int		quit = ZERO;
	if(isnull(bfn))	{
		errmsg("<no buffer to save>\n");
		terror(FUBAR);
		}
/**/
	if(*is == 'x')	is += 1;
	if(*is == 'q')	quit = *is++;
/**/
	cdx.chg = 1;
	undo(BWRT,here);
	cdx.chg = 1;
	undo(BWRT,here);
	undo(BCLS,here);
/**/
	newbuf(is);
/**/
	if(quit)	{
		ukedmail();
		exit(0);
		}
/**/
	orphans('x',"kedexit",NULL);
	tellfile(TERSE);
	efn[0] = bfn[0] = ZERO;
	clredit();
/**/
	return;
}
void
doexit(ty)
int	ty;
{
	clredit();
	exit(ty);
}
newbuf(is)			/* rename the buffer */
char	*is;
{
/**/
	if(isnull(is) || strcmp(is,bfn) == 0)	{
		return(0);
		}
/**/
	if(is[0] == '!')		is += 1;
	else
	if(access(is,0) == 0)	{
		errmsg("newbuf <use x! to replace> '%s'\n",is);
		terror(FUBAR);
		}
/**/
	strcnd(is);
/**/
	if(linkorcopy(bfn,is))	terror(FUBAR);
/**/
	strcpy(bfn,is);
/**/
	return(0);
}
#ifdef	LOCKING
orphans(ty,os,is)
int		ty;		/* function type */
char	*os;	/* calling routine */
char	*is;	/* file name (usually NULL) */
{
	auto	char	ws[FNMSIZ];
	auto	int		rt;
#ifdef	__MSDOS__
	auto	char	*xf = "orphans.exe";
#else	/*__MSDOS__*/
	auto	char	*xf = "orphans.x";
#endif	/*__MSDOS__*/
	auto	char	*fn;
	auto	char	*bn;
	if(kenv.flags0 <=0)	return(-3);
/*
	call the lock function with the following information:
	-b	str	file name for buffer
	-e	str	file name for edit/scan file
	-f 	c	function character
	-p	n	process id
	-s	str	file name to scan for
*/
	if(is)		fn = is;
	else
	if(efn[0])	fn = efn;
	else		fn = "NONE";
/**/
	bn = bfn[0] ? bfn : "NONE";
/**/
	if(strcmp(fn,"NONE") == 0 && strcmp(fn,bn) == 0)	return(0);
/**/
	sprintf(ws,"%s -f %c -p %u -b %s -e %s",
		xf,
		ty,
		getpid(),
		bn,
		fn);
/**/
#ifdef	DEBUG
	fprintf(stderr,"%s\n",ws);
	query(stderr);
#endif	/*DEBUG*/
#ifdef	USEFORK
	if(gofork(ws))	{
#else	/*USEFORK*/
	if(system(ws))	{
#endif	/*USEFORK*/
/*
	failure can occur in two ways here:
	(a)	orphans could not be executed;
	(b)	orphans executed but one of the tests failed.
*/
		bfp = xfclose( bfp );
		if(gofucked())	{
/*
	failed due to fork problems, don't know about status of buffer
*/
			errmsg("orphans <abandoned> '%s'\n",bfn);
			errmsg("orphans <locking turned off>\n");
			kenv.flags0 = 0;
			}
		else
		if(ty == 'X' || cdx.chg)	{
/*
	failed, but this is a recovery buffer, so hang on to it
*/
			errmsg("orphans <retained> '%s'\n",bfn);
			}
		else	{
			errmsg("orphans <removed> '%s'\n",bfn);
			unlink(bfn);
			}
		bfn[0] = efn[0] = 0;
		if(ty == 'q')	exit(FUBAR);
		else			terror(FUBAR);
		}
/**/
	return(0);
}
#else	/*LOCKING*/
orphans(ty,os,is)
int		ty;
char	*os;
char	*is;
{
	return(0);
}
#endif	/*LOCKING*/
/**/
void
doquit(is)
char *is;
{
	if(*is == 'w')  ++is;
	if(*is == 'q')  ++is;
	if(*is != '!')	{
		if(cdx.chg >= YES)	{
			errmsg("<use q! to discard changes>\n");
			terror(FUBAR);
			}
		if(cdx.lst >= 1 && !isnull(bfn) && filesize(efn) <= 0L)	{
			errmsg("<cannot find> '%s'\n",efn);
			errmsg("<use x  to save buffer>    '%s'\n",bfn);
			errmsg("<use q! to discard buffer> '%s'\n",bfn);
			terror(FUBAR);
			}
		}
	orphans('q',"doquit",NULL);
	clredit();
	if(kenv.diagno == ZERO && (kenv.leisur & DA))	scr_cl(stdout);
	exit(0);
}
ukedmail()
{
	auto	char	ws[FNMSIZ];
	sprintf(ws,"ukedmail %s %s",efn,bfn);
#ifdef	USEFORK
	return(gofork(ws));
#else	/*USEFORK*/
	return(system(ws));
#endif	/*USERFORK*/
}
