/*
	89:01:15	modified to use less stack. work strings from headp
*/
/*
Expand wild cards and shell variables.
*/
/*DOSLIB*/
/*UNXLIB*/
/**/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include	"ksysprot.h"
/**/
#ifdef		MSDOS
#include	<dos.h>
#include	"kdosdir.h"
#endif
/**/
/*EXTERN*/
#ifdef	CAN_PROTO
#ifndef	__TURBOC__
extern	void	qsort(void *,int,int,int (*)());
extern	void	free(char *);
#endif	/*__TURBOC__*/
extern	int		findnext(char *);
extern	int		findfirst(char *, char *, int);
#else
extern	void	qsort();
extern	void	free();
extern	int		findnext();
extern	int		findfirst();
#endif
extern  KENV    kenv;
/**/
#define		PATSEP	'/'
#define		DOLLAR	'$'
/**/
#define	UWORK	"/usr/tmp/xsXXXXXX.tmp"
/**/
char	*
fexpand(is)		/* expand the names in _is */
char	*is;
{
	auto	char	*wsx = dosxenv(is);
	auto	char	*rsx = NULL;
/*
	expand any shell variables using dosxenv()
	expand wildcards using dosx() or unxx() as appropriate
	each of these routines returns a saved string.  that returned
	by dosxenv() can be freed.
*/
	if(wsx != NULL)	{
		if(kenv.dosdos)			rsx = dosx(wsx);
		else					rsx = unxx(wsx);
		wsx = free_if(wsx);
		}
	if(rsx != NULL)	strcnd(rsx);
	return(rsx);
}
char	*
xpandsh(os,us)	/* expand file names and shell vars */
char	*os;	/* string to expand */
char	*us;	/* upper limit to string */
{
#ifdef	DEBUG
	auto	int		barf = fprintf(stderr,"xpandsh(%s,%u)\n",os,us);
#endif
	auto	char	*rsx = NULL;
	auto	char	*osx = NULL;
	auto	char	*wsx = NULL;
/**/
	wsx = dosxenv(os);	/* expand shell variables if any */
#ifdef	DEBUG
	fprintf(stderr,"%s = dosxenv(%s)\n",wsx,os);
#endif
/**/
	if(kenv.dosdos)			rsx = dosx(wsx);
	else					rsx = unxx(wsx);
/**/
	if(!rsx)				rsx = wsx;
/**/
/*
	for backward compatibility
*/
	if(us)	{
		os[0] = ZERO;
		osx = strkat(os,us,rsx);
		if(osx >= us)	{
			errmsg("xpandsh <truncation>\n");
			}
		free(rsx);
		rsx = os;
		}
	else	osx = rsx;
	return(strcnd(rsx));
}
#ifdef	MSDOS
alphasort(os,is)
char	**os;
char	**is;
{
	return(strcmp(*os,*is));
}
char	*
dosx(is)	/* expand shell variables and file names */
char	*is;
{
#ifdef	TRACE
	auto	int		barf = fprintf(stderr,"dosx(%s)\n",is);
#endif	TRACE
	auto	char	ws[FNMSIZ];
	auto	char	*rs = NULL;
	auto	char	*xs;
	while((int)(is = xgnc(ws,ws+FNMSIZ-1,is,' ')))	{
		xs = dosxf(ws);
		if(xs == NULL)		rs = stradd(rs,ws);
		else				rs = stradd(rs,xs);
		}
	return(rs);
}
char	*
dosxf(is)	/* expand dos filenames in _is */
char	*is;
{
#ifdef	TRACE
	auto	int		barf = fprintf(stderr,"dosxf(%s)\n",is);
#endif	TRACE
	auto	struct	ffblk	ffblk;
	auto	int		done;
	auto	char	*rs = NULL;
	auto	char	*wsx;
	auto	char	**np = NULL;
	auto	int		nf = 0;
	auto	int		i;
	auto	int		loop = BUFSIZ;
	auto	char	*bs = NULL;
	auto	char	*ws = NULL;
/**/
	if(bs == NULL)	bs = emalloc(FNMSIZ,"dosxf:bs");
	if(ws == NULL)	ws = emalloc(FNMSIZ,"dosxf:ws");
/**/
	dosfp(bs,bs+FNMSIZ-1,is);
/**/
	done = findfirst(is,(char *) &ffblk,0);
/**/
	np = (char **) emalloc(BLKSIZ * sizeof(char **),"dosxf");
/**/
	while(loop-- >= 1 && !done)	{
/**/
		wsx = ws;
		if(!isnull(bs))	{
			wsx = strkat(wsx,ws+FNMSIZ-1,bs);
			*wsx++ = PATSEP;
			}
		wsx = strkat(wsx,ws+FNMSIZ-1,ffblk.ff_name);
/**/
		if(nf >= BLKSIZ)	{
			errmsg("dosxf <too many names> '%u'\n",nf);
			fubar(FUBAR);
			}
/**/
		np[nf] = strsave(ws);
/**/
		nf += 1;
/**/
		done = findnext( (char *) &ffblk);
		}
/**/
	if(!nf)	{
		bs = free_if(bs);
		ws = free_if(ws);
		return(NULL);
		}
/**/
	if(!np)	{
		errmsg("FUBAR\n");
		fubar(FUBAR);
		}
	qsort(np,nf,sizeof(char*),alphasort);
/**/
	for(i = 0; i < nf; i++)	{
		rs = stradd(rs,strlwr(np[i]));
		free(np[i]);
		}
/**/
	np = (char **) free_if( (char *) np);
/**/
	bs = free_if(bs);
	ws = free_if(ws);
	return(rs);
}
char	*
dosfp(os,us,is)		/* parse dos file name */
char	*os;
char	*us;
char	*is;
{
#ifdef	TRACE
	auto	int		barf = fprintf(stderr,"dosfp(%u,%u,%s)\n",os,us,is);
#endif	TRACE
	auto	char	*eop = NULL;
	REG	char	*osx = os;
	REG	char	*isx = is;
	REG	char	*usx = us;
	while(osx < usx && *isx != ZERO)
	if(*isx == ':')	{
		*osx++ = *isx++;
		eop = osx;
		break;
		}
	else	*osx++ = *isx++;
	if(!eop)	{
		isx = is;
		osx = os;
		}
#define	ispath(x)((x == '/' || x == '\\') ? 1 : 0)
	while(osx < usx && *isx != ZERO)
	if(ispath(*isx))	{
		while(ispath(*isx))	++isx;
		eop = osx;
		*osx++ = '/';
		}
	else	*osx++ = *isx++;
	*osx = ZERO;
	if(eop == NULL)	{
		os[0] = ZERO;
		return(is);
		}
	*eop = ZERO;
	return(is);
}
char	*
unxx(is)
char	*is;
{
	return(is);
}
#else
char	*
dosx(is)
char	*is;
{
	return(is);
}
char	*
unxx(is)	/* expand _is for unix */
char	*is;
{
	auto	char	*work = NULL;
	auto	char	*xcmd = NULL;
	auto	char	*rsx = NULL;
/**/
	if(!hasvars(is))	return(strsave(is));
/**/
	if(work == NULL)	work = emalloc(FNMSIZ,"unxx:work");
	if(xcmd == NULL)	xcmd = emalloc(FNMSIZ,"unxx:xcmd");
/**/
	strcpy(work,UWORK);
	maketemp(work);
/**/
	sprintf(xcmd,"exec echo %s > %s\n",is,work);
/**/
	if(system(xcmd) || filesize(work) <= 1L)	{
		errmsg("xpandsh <failed> %s\n",xcmd);
		}
	else	{
		rsx = blkrd(work);
		}
/**/
	unlink(work);
/**/
	work = free_if(work);
	xcmd = free_if(xcmd);
/**/
	return(rsx);
}
#endif
/**/
hasvars(is)	/* shell vars or wild cards ? */
char    *is;
{
		REG        char    *isx = is;
		while(*isx != ZERO)
		if(strchr("$?*[`",*isx++))       return(1);
		return(0);
}
cmdxpd(argc,argv)
int		argc;
char	*argv[];
{
	auto	int		i;
	auto	char	*xp = kgetenv("EXPAND");
	auto	int	ex = YES;
/**/
	if(isnull(xp))	ex = YES;
	else
	if(strkmp(xp,"YES") == 0)	ex = YES;
	else
	if(strkmp(xp,"NO") == 0)	ex = NO;
/**/
	if(ex)	{
		for(i = 1; i < argc; i++)	
		if(strncmp(argv[i],"-Q",2) == ZERO)	{
			argv[i] = NULL;
			while(i < argc)
				if(strncmp(argv[i],"-Q",2) == ZERO)	{
					argv[i] = NULL;
					break;
					}
				else	i += 1;
			}
		else
		if(*argv[i] == '-')	argv[i] = strsave(argv[i]);
		else				argv[i] = xpandsh(argv[i],NULL);
		}
/**/
	return(argc);
}
#ifdef	TEST
KENV	kenv;
main()
{
	auto	char	ls[FNMSIZ];
	auto	char	*xs;
	kenv.diagno = 0;
	kenv.dosdos = isdos();
	disnme(kenv.pname = "xpandsh");
	while(putchar('?'),gets(ls))	{
		if(ls[0] == 'q')	break;
		xs = xpandsh(ls,NULL);
		puts(xs);
		xs = free_if(xs);
		}
}
#endif	TEST
