/*UNXLIB*/
/*DOSLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#ifdef	__TURBOC__
#include	<time.h>
#define		MAXTMS	16
typedef struct	TMS_STACK	{
	clock_t		start;
	char		*place;
	}	TMS_STACK;
TMS_STACK	tms_stack[MAXTMS];
short	int	tms_depth;
timeit(ty,is)
int		ty;
char	*is;
{
	if(ty == 0)	{	/* set stack */
		if(tms_depth >= MAXTMS)	{
			errmsg("timeit <overflow>\n");
			terror(FUBAR);
			}
		tms_stack[tms_depth].start = clock();
		tms_stack[tms_depth].place = strsave(is);
		tms_depth += 1;
		}
	else
	if(ty == 1)	{
		auto	clock_t		endof;
		if(tms_depth <= 0)	{
			errmsg("timeit <underflow>\n");
			terror(FUBAR);
			}
		tms_depth -= 1;
		endof = clock();
		endof -= tms_stack[tms_depth].start;
		fprintf(stderr,"%16.16s ",tms_stack[tms_depth].place);
		free_if( tms_stack[tms_depth].place );
		fprintf(stderr,"%5.2f seconds", (double) endof / CLK_TCK);
		fprintf(stderr,"\n");
		}
	return;
}
#else	__TURBOC__
#include	<sys/types.h>
#include	<sys/times.h>
#include	<sys/param.h>
#define		MAXTMS	16
#ifndef		HZ
#define		HZ	60
#endif		/*HZ*/
#ifdef	CAN_PROTO
extern time_t times(struct tms *);
#else	/*CAN_PROTO*/
extern time_t times();
#endif	/*CAN_PROTO*/
typedef	struct	TMS_STACK	{
	struct	tms	tms_times;
	time_t		tms_start;
	char		*tms_place;
	}	TMS_STACK;
TMS_STACK	tms_stack[MAXTMS];
short	int	tms_depth;
timeit(ty,is)
int		ty;
char	*is;
{
	if(ty == 0)	{	/* push to stack */
		time(&tms_stack[tms_depth].tms_start);
		times(tms_stack+tms_depth);
		tms_stack[tms_depth].tms_place = strsave(is);
		tms_depth += 1;
		}
	else
	if(ty == 1)	{	/* pop from stack, calculate */
		auto	float		etime;
		auto	float		utime;
		auto	float		stime;
		auto	time_t		tms_endof;
		auto	struct	tms	tms_owari;
		tms_depth -= 1;
		time(&tms_endof);
		times(&tms_owari);
		tms_endof -= tms_stack[tms_depth].tms_start;
		tms_owari.tms_utime -= tms_stack[tms_depth].tms_times.tms_utime;
		tms_owari.tms_stime -= tms_stack[tms_depth].tms_times.tms_stime;
		etime = (float) tms_endof;
		utime = (float) tms_owari.tms_utime / (float) HZ;
		stime = (float) tms_owari.tms_stime / (float) HZ;
		fprintf(stderr,"%-16.16s ",tms_stack[tms_depth].tms_place);
		fprintf(stderr,"etime %5.2f utime %5.2f stime %5.2f\n",
			etime,utime,stime);
		free_if(tms_stack[tms_depth].tms_place);
		}
	return(tms_depth);
}
#endif	/*__TURBOC__*/
