#define		TIME_CHECK
#define		DEBUG
#undef		DEBUG
#undef		CAN_SEEK
#define		CAN_SEEK
#undef		BIG_BUF
#define		BIG_BUF
#include	"pdtar.h"
#include	"pdproto.h"
/**/
/*EXTERN*/
/**/
badtype(f_name,ty)
char	*f_name;
int		ty;
{
	switch(ty)	{
		case	LF_NOR:
		case	LF_OLD:
		case	LF_CHR:
		case	LF_LIN:
		case	LF_BLK:
			return(0);
		default:
			fprintf(stderr,"%s\n<unknown file type> %d\n",f_name,ty);
			return(1);
	}
}
void
wrongx(f_name,part,want)
char	*f_name;
int		part;
int		want;
{
	fprintf(stderr,"%s\n<wrong extent> got %d, wanted %d\n",
		f_name,part,want);
	terror(FUBAR);
	return;
}
extract()
{
	static	char	*here = "extract";
	auto	RECORD	*header = &curhead;
	auto	int		loop = 5;
	auto	int		eoa;
	auto	int		expect = 1;
	auto	int		tails = 0;
	auto	int		maxrec = BUFSIZ;
	phstat = &hstat;
/**/
	rewind(xfp);
	rewind(lfp);
/**/
	while(tails < 2 && loop >= 1)	{
		tar_fetch((char *) header,1,here);
		eoa = ishead(header);
/**/
		if(eoa == T_HEAD)	{
			tails = 0;
			decode(header);
			if(!accept(f_rname,phstat))	{
				if(lf_typ != LF_LIN)	doskip(f_name,phstat);
				continue;
				}
/**/
			if(badtype(f_name,lf_typ))	{
				doskip(f_name,phstat);
				continue;
				}
/**/
			if(oswitch.extract && device.extotal && 
					device.extno != expect)	
						wrongx(f_name,device.extno,expect);
/**/
			if(lf_typ == LF_LIN)	{
				if(!accept(l_rname,phstat))	continue;
				if(oswitch.extract) 	dolink(l_name,f_name,phstat);
				if(oswitch.verbose)		prhead(f_name,phstat);
				else
				if(oswitch.listing)		prhead(f_name,phstat);
				}
/**/
			else	{
				if(oswitch.extract)		wrfile(f_name,phstat);
				if(oswitch.verbose)		prhead(f_name,phstat);
				else
				if(oswitch.listing) 	prhead(f_name,phstat);
				if(!oswitch.extract) 	doskip(f_name,phstat);
				if(device.extno == device.extotal) expect = 1;
				else	expect = device.extno + 1;
				}
			}
		else
		if(eoa == T_TAIL)	{
			tails += 1;
			if(device.extno < device.extotal)	{ 
				askfloppy(NULL);
				tails = 0;
				}
			else	break;
			}
		else	{
			where(here);
			fprintf(stderr,"%s <unknown block type> %d\n",here,eoa);
			if(oswitch.recover && maxrec-- >= 1)	continue;
			else									loop -= 1;
			}
	}	/* while(loop) */
/**/
	notfound();
/**/
	return(0);
}
#ifdef	MSDOS
dupelink(os,is,phstat)
char	*os;		/* existing file */
char	*is;		/* file to be copied */
STAT	*phstat;	/* stat from archive */
{
	static	char	*here = "dupelink";
	auto	FILE	*ifp;
	auto	FILE	*ofp;
	auto	int		cx;
/**/
	unlink(is);	/* trash existing */						
/**/
	if(makepath(is))	return(-1);	/* make path if needed */
/**/
	if((ofp = efopen(is,"wb",here)) == (FILE *) NULL)	return(FUBAR);
/**/
	if((ifp = efopen(os,"rb",here)) == (FILE *) NULL)	return(FUBAR);
/**/
	while((cx = getc(ifp)) != EOF)	putc(cx,ofp);
/**/
	fclose(ofp);
	fclose(ifp);
/**/
	if(oswitch.usetime)	dotime(is,phstat);
	if(oswitch.useperm)	doperm(f_name,phstat);
	return(0);
}
#else
dupelink(os,is,phstat)
char	*os;
char	*is;
STAT	*phstat;
{
	static	char	*here = "dupelink";
	unlink(is);
	if(makepath(is))	return(-1);
	if(link(os,is))	{
		extern	int	errno;
		fprintf(stderr,
			"%s <link error %u> '%s' -> '%s'\n",
				here,errno,os,is);
		return(-1);
		}
	return(0);
}
#endif
dolink(os,is,phstat)
char	*os;		/* existing file */
char	*is;		/* linked file */
STAT	*phstat;
{
	static	char	*here = "dolink";
#ifdef	MSDOS
	if(!oswitch.copylink)	{
		fprintf(stderr,"pdtar <cannot link> '%s' -> '%s'\n",os,is);
		return(-1);
		}
	else	return(dupelink(os,is,phstat));
#else
	return(dupelink(os,is,phstat));
#endif
}
docrap(is,phstat)
char	*is;
STAT	*phstat;
{
	fprintf(stderr,"pdtar <unknown file type> '%s'\n",is);
	return(0);
}
dodirt(is,phstat)
char	*is;
STAT	*phstat;
{
	fprintf(stderr,"pdtar <directory ignored> '%s'\n",is);
	return(0);
}
doperm(is,phstat)
char	*is;
STAT	*phstat;
{
	auto	int		err;
	static	char	*here = "doperm";
	if((err = chmod(is, (int) phstat->st_mode)) < 0)	{
		where(here);
		perror(is);
		}
	return(err);
}
dotime(is,phstat)	/* set the file time to archive time */
char	*is;
STAT	*phstat;
{
	static	char	*here = "dotime";
#ifdef	TIME_CHECK
	static	time_t	now = 0L;
	auto	STAT	sb;
#endif	/*TIME_CHECK*/
	auto	int		err;
	auto	time_t	amt[2];
/**/
	if(phstat->st_mtime % 2)	phstat->st_mtime += 1;
	amt[0] = amt[1] = phstat->st_mtime;
/**/
	if((err = utime(is,amt)) < 0) {
		where(here);
		perror(is);
		return(err);
		}
#ifdef	TIME_CHECK
	if(now == 0L)	time(&now);
	if((err = badstat(is,&sb,"dotime")) < 0)	{
		return(err);
		}
	if(sb.st_mtime != phstat->st_mtime)	{
		where(here);
		fprintf(stderr,"<time set error> %s %lu != %lu\n",
			is,sb.st_mtime,phstat->st_mtime);
		timeshit(sb.st_mtime,"!=",phstat->st_mtime);
		return(-1);
		}
	if(sb.st_mtime >= now)	{
		where(here);
		fprintf(stderr,"<time set error> %s %lu >= %lu\n",
			is,sb.st_mtime,now);
		timeshit(sb.st_mtime,">=",now);
		return(-1);
		}
#endif	/*TIME_CHECK*/
/**/
	return(0);
}
#ifdef	TIME_CHECK
timeshit(at,rs,bt)
long	at;
char	*rs;
long	bt;
{
	auto	char	as[32];
	auto	char	bs[32];
	strcpy(as,ctime(&at));
	strcpy(bs,ctime(&bt));
	strcnd(as);
	strcnd(bs);
	fprintf(stderr,"%s %s %s\n",as,rs,bs);
	return(0);
}
#endif
doskip(f_name,phstat)
STAT	*phstat;
char	*f_name;
{
	static	char	*here = "doskip";
	auto	long	size = phstat->st_size;
	auto	long	skip_blks;
	auto	long	skip_chrs;
	auto	long	err = 0;
	auto	char	buf[BLKSIZ];
	skip_blks = cal_bif(size);
	skip_chrs = skip_blks * BLKSIZ;
#ifdef	DEBUG
fprintf(stderr,"skip blocks(%ld) for %s\n",skip_blks,f_name);
#endif	/*DEBUG*/
#ifdef	CAN_SEEK
/**/
	if(device.bpf && oswitch.rawio)		{
		device.rbc += (int) skip_blks;
		}
	else
	if(oswitch.nottape)				{
		err = lseek(device.ifd,skip_chrs, 1);
		}
	else
	while(skip_blks-- >= 1)			{
		tar_fetch((char *) buf,1,here);
		}
/**/
	if(err < 0L)	{
		where(here);
		perror(afn);
		}
#else
	while(skip_blks-- >= 1)	tar_fetch((char *) buf,1,here);
#endif
	return(0);
}
doerrs(f_name,size)
char	*f_name;
long	size;
{
	phstat->st_size = size;
	return(doskip(f_name,phstat));
}
wrfile(f_name,phstat)
char	*f_name;
STAT	*phstat;
{
	static	char	*here = "wrfile";
	static	int		mode = O_CREAT | O_WRONLY | O_BINARY;
	static	int		perm = 0777;
	auto	long	osize = 0L;
	auto	int		write_ofd;
#ifdef	BIG_BUF
#else
	auto	char	buf[BLKSIZ];
#endif
	auto	long	size = 0L;
	auto	int		nci = 0;
	auto	int		nco = 0;
	auto	STAT	sb;
/**/
	if(makepath(f_name))	{
		doskip(f_name,phstat);
		return(1);
		}
/**/
	if(device.extno <= 1)	write_ofd = open(f_name,mode | O_TRUNC,perm);
	else			write_ofd = open(f_name,mode,perm);
/**/
	if(write_ofd < 0)	{
		where(here);
		perror(f_name);
		doerrs(f_name,phstat->st_size);
		return(1);
		}
/**/
	if(device.extno > 1)	lseek(write_ofd,0L,2);	/* end of file */
/**/
	size = phstat->st_size;
/**/
#ifdef	BIG_BUF
	{
	auto	int		read_blks;
	while(nci == nco && size >= 1)	{
		read_blks = cal_bif(size);
		if(device.ifd == 0)	{
			read_blks = read_blks >= NBIP ? NBIP : read_blks;
			}
		else	{
			read_blks = read_blks >= NBUF ? NBUF : read_blks;
			}
		read_blks = tar_fetch(rbuf,read_blks,here);
		if(size >= (BLKSIZ * read_blks))	nci = BLKSIZ * read_blks;
		else						nci = size;
		nco = write(write_ofd,rbuf,nci);
		if(nci != nco)	{
			where(here);
			perror(f_name);
			doerrs(f_name,size);
			}
		size -= nco;
	}
	}
#else
	while(nci == nco && size >= 1)	{
		tar_fetch((char *) buf,1,here);
		nci = (size >= BLKSIZ) ? BLKSIZ : size;
		nco = write(write_ofd,buf,nci);
		if(nci != nco)	{
			where(here);
			perror(f_name);
			doerrs(f_name,size);
			}
		size -= nco;
	}
#endif
/**/
	close(write_ofd);
/**/
	if(stat(f_name,&sb))	{
		where(here);
		perror(f_name);
		return(1);
		}
/**/
	if(device.extno == device.extotal)	{
		osize = device.efsize ? device.efsize : phstat->st_size;
			if(sb.st_size != osize)	{
			where(here);
			fprintf(stderr,"<size error> %ld != %ld %s\n",
				sb.st_size,osize,f_name);
			}
		}
	if(oswitch.usetime) dotime(f_name,phstat);
	if(oswitch.useperm)	doperm(f_name,phstat);
	return(0);
}
ishead(head)
RECORD	*head;
{
	auto	long		chksum;
	auto	long		calsum = 0L;
	auto	char		*px = head->charptr;
	auto	unsigned	ix = BLKSIZ;
	auto	int			ty;
	chksum = from_oct(8,head->header.chksum);
	while(ix-- >= 1)	calsum += 0xFF & *px++;
	px = head->header.chksum;
	for(ix = 0; ix < 8; ix++)	calsum -= 0xFF & px[ix];
	calsum += ' ' * 8;
	if(calsum == chksum)	ty = T_HEAD;
	else
	if(calsum == 8 * ' ')	ty = T_TAIL;
	else					{
		fprintf(stderr,"ishead <bad checksum> %ld %ld\n",calsum,chksum);
		ty = T_CRAP;
		}
/*
fprintf(stderr,"ishead(%d)\n",ty);
*/
	return(ty);
}
askfloppy(is)
char	*is;
{
	auto	char	ls[NAMSIZ];
	if(oswitch.archive) 	tar_write(T_CLOSE);
	else
	if(oswitch.listing)		tar_read(T_CLOSE);
	else
	if(oswitch.extract)		tar_read(T_CLOSE);
/**/
	device.rbc = device.wbc = 0;		/* important */
/**/
#ifdef	MSDOS
	rawreset(device.rawd);
#else
	sync();
#endif
	fflush(stdrpt);
/**/
	if(is)	{
		fputs(is,stderr);
		fputs("\n",stderr);
		}
	else	{
		fprintf(stderr,"\007<insert floppy, carriage return>");
		}
	fgets(ls,NAMSIZ-1,stdask);
	if(oswitch.archive) 	tar_write(T_OPEN);
	else
	if(oswitch.listing)		tar_read(T_OPEN);
	else
	if(oswitch.extract)		tar_read(T_OPEN);
	return(0);
}
rawread(os,nb,bn)
char	*os;		/* buffer */
int		nb;			/* number of blocks */
int		bn;			/* block number */
{
	return(absio(BIOS_READ,device.rawd,os,nb,bn));
}
rawwrite(os,nb,wb)
char	*os;	/* buffer */
int		nb;		/* blocks in buffer */
int		wb;		/* block to start write */
{
#define	BLOCK
#ifdef	BLOCK
	return(absio(BIOS_WRITE,device.rawd,os,nb,wb));
#else
	auto	int		ix;
	auto	int		rx;
	for(ix = 0; ix < nb; ix++)	{
		rx += absio(BIOS_WRITE,device.rawd,os + (ix * BLKSIZ) ,1,wb+ix);
	}
	return(rx);
#endif
}
sysread(os,nb)
char	*os;	/* buffer for output */
int		nb;		/* number of blocks to read */
{
	static	char	*here = "sysread";
	auto	int		nci;
	auto	int		nco = 0;
	nci = BLKSIZ * nb;
	nco = read(device.ifd,os,nci);
#ifdef	DEBUG
		fprintf(stderr,"nci(%d) nco(%d)\n",nci,nco);
#endif	/*DEBUG*/
	/* if(nco < 0 || nco != nci)	{ */
	if(nco < 0)	{
		where(here);
		perror(afn);
		terror(FUBAR);
		}
	return(nco / BLKSIZ);
}
syswrite(os,nb)
char	*os;	/* buffer to write */
int		nb;		/* blocks to write */
{
	static	char	*here = "syswrite";
	auto	int		nci;
	auto	int		nco;
#ifdef	DEBUGR
	extern	long	lseek();
	auto	long	last_write;
	last_write = lseek(device.ofd,0L,1);
#endif	/*DEBUG*/
	nci = BLKSIZ * nb;
	nco = write(device.ofd,os,nci);
	if(nco < 0 || nco != nci)	{
		where(here);
		perror(afn);
		terror(FUBAR);
		}
	return(nco);
}
tar_place(os,nb,is)
char	*os;	/* block to write */
int		nb;		/* number of blocks */
char	*is;	/* for tracing */
{
	static	char	*here = "tar_place";
#ifdef	__TURBOC__
	extern	int		(*wfunc)(char *, int, int);
#endif
	if(device.bpf && device.wbc && (device.bpf - device.wbc) <= SLOP)	{
		auto	char	buf[BLKSIZ];
		memset(buf, 0, BLKSIZ);
		while(device.wbc < device.bpf)	{
			(*wfunc)(buf,1,device.wbc++);
			}
		device.wbc = askfloppy(NULL);
		}
/**/
	(*wfunc)(os,nb,device.wbc);
/**/
	return(device.wbc += nb);
}
tar_fetch(os,nb,is)
char	*os;	/* receiving buffer */
int		nb;		/* number of blocks to fetch */
char	*is;	/* for tracing */
{
	static	char	*here = "tar_fetch";
#ifdef	__TURBOC__
	extern	int		(*rfunc)(char *,int,int);
#endif
	auto	int		blocks;
/**/
	blocks = (*rfunc)(os,nb,device.rbc);
/**/
	device.rbc += blocks;
/**/
	return(blocks);
}
