/*DOSLIB*/
/*UNXLIB*/
#define		DEBUG
#undef		DEBUG
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<signal.h>
#define		BIGBLK		1024
#define		NGROUP		2048
#define		ERR			-1
#define		FUG			32
#define		NYA			1
#define		BIG			2
#define		WRT			3
typedef	struct	GROUP	{
	NOSIGN		fsize;	/* file size in rounded blocks */
	NOSIGN		inumb;	/* inumber */
	long		fname;	/* address of name in work file */
	}	GROUP;
GROUP	group[NGROUP];
NOSIGN	ngrp;			/* number of groups */
NOSIGN	want;			/* blocks per group */
NOSIGN	style;			/* style for output */
NOSIGN	fover;			/* overhead blocks per file */
NOSIGN	lover;			/* overhead blocks per link */
NOSIGN	blksiz;			/* block size used by archive program */
struct	stat	sb;		/* stat buffer */
char	ls[BLKSIZ];		/* general line buffer */
char	*tmpdir;		/* temporary directory */
char	wfn[FNMSIZ];	/* workfile name */
FILE	*wfp;			/* workfile pointer */
KENV	kenv;
/*EXTERN*/
#ifdef	CAN_PROTO
extern FILE *makework(char *);
extern void dosorts(NOSIGN);
#else
extern FILE *makework();
extern void dosorts();
#endif
/**/
void
terror(ty)
int	ty;
{
	unlink(wfn);
	system("rm -f group???.tmp");
	exit(ty);
}
/**/
dogroup(want)
NOSIGN	want;
{
	auto	NOSIGN	ix;
	auto	long	ad;
	auto	char	ls[FNMSIZ];
	auto	char	ws[FNMSIZ];
	auto	NOSIGN	this;
	auto	NOSIGN	have = 0;
	auto	NOSIGN	ng = 0;
	auto	NOSIGN	flip = 0;
	sprintf(ws,"group%03d.tmp",ng++);
	freopen(ws,"w",stdout);
	for(ix = 0; ix < ngrp; ix++)	{
		ad = group[ix].fname;
		efseek(wfp,ad,0);
		fgetls(ls,ls+FNMSIZ-1,wfp);
		this = group[ix].fsize + fover;
#ifdef	DEBUG
	fprintf(stderr,"ng %4u this %4u want %4u have %4u %s\n",
		ng,this,want,have,ls);
#endif
		if(this > want)				flip = 1;
		else
		if( (this + have) > want)	flip = 2;
/**/
		if(flip)	{
			if(flip == 1)	{
				errmsg("<file larger than group> %s\n",ls);
				if(kenv.flags0)		{
					terror(FUBAR);
					}
				have = this;
				puts(ls);
				}
			if(kenv.report & DC)	{
				print("%u %s\n",have,ws);
				}
			sprintf(ws,"group%03d.tmp",ng++);
			freopen(ws,"w",stdout);
			flip = have = 0;
			continue;
			}
		have += this;
		puts(ls);
		if(kenv.report & DB)
		print("%u %u %u %s\n",have,group[ix].fsize,group[ix].inumb,ls);
		}
	if(kenv.report & DA) prwho(" %d group(s)\n",ng);
	return(ng);
}
/**/
dofiles(fp)
FILE	*fp;
{
	auto	char	*lsx;
	auto	char	ws[FNMSIZ];
	auto	NOSIGN	used = 0;
	while(fgetls(lsx = ls,ls+BLKSIZ-1,fp))	{
		while((int) (lsx = xgnc(ws,ws+FNMSIZ-1,lsx,' ')))	{
			strcnd(ws);
			if(kenv.flags2 && ws[0] == '/')	strcpy(ws,ws+1);
			used = dostat(ws);
			}
		}
	return(used);
}
sizesort(lg,rg)
GROUP	*lg;
GROUP	*rg;
{
	auto	int		ret;
#ifdef	DEBUGR
	printf("lg->fsize(%u) ",lg->fsize);
	printf("rg->fsize(%u) ",rg->fsize);
	printf("\n");
#endif
	ret = lg->fsize - rg->fsize;
	if(ret == 0)	ret = lg->inumb - rg->inumb;
	return(ret);
}
void
dosorts(nf)
NOSIGN	nf;		/* number of files */
{
	qsort( (char *) group, nf, sizeof(GROUP), sizesort);
	return;
}
dostat(is)
char	*is;
{
	if(ngrp >= NGROUP)			{
		errmsg("dostat <too many groups> %u >= %u\n",ngrp,NGROUP);
		terror(FUBAR);
		}
	if(stat(is,&sb) != ZERO)	{
		prterr("dostat: '%s'",is);
		if(kenv.flags0)	terror(FUBAR);
		else			return(ERR);
		}
	if(!(sb.st_mode & S_IFREG))	{
		errmsg("dostat: not a regular file\n");
		if(kenv.flags0)	terror(FUBAR);
		else			return(ERR);
		}
	group[ngrp].inumb = sb.st_ino;
	group[ngrp].fsize = (NOSIGN) (sb.st_size / (long) blksiz);
	if(sb.st_size % (long) blksiz)	group[ngrp].fsize += 1;
	group[ngrp].fname = eftell(wfp);
	fprintf(wfp,"%s\n",is);
#ifdef	DEBUGR
	fprintf(stderr,"%6u %6u %6u %6ld %6ld %s\n",
		ngrp,group[ngrp].inumb,group[ngrp].fsize,sb.st_size,
			group[ngrp].fname,is);
#endif
	return(++ngrp);
}
FILE	*
makework(is)
char	*is;
{
	sprintf(wfn,"%s/%s",is,"grXXXXXX.tmp");
	maketemp(wfn);
	if(!(int) (wfp = efopen(wfn,"w+")))	exit(FUBAR);
	return(wfp);
}
main(argc,argv)
int		argc;
char	*argv[];
{
	disnme("group");
	kenv.dosdos = isdos();
	if(cmdnum(argc,argv,'h',0,1))	hint(0);
	if(cmdnum(argc,argv,'H',0,1))	{
		whoru(stdout);
		hint(0);
		}
	if(!(int) (tmpdir = kgetenv("TMPDIR")))	tmpdir = "/usr/tmp";
	wfp = makework(cmdstr(argc,argv,'T',tmpdir));
/**/
	signal(SIGINT,terror);
/**/
	kenv.flags0 = cmdnum(argc,argv,'a',0,DA);
	kenv.flags1 = cmdnum(argc,argv,'z',DA,0);
	kenv.flags2 = cmdnum(argc,argv,'r',0,DA);
	kenv.report = cmdnum(argc,argv,'v',DA|DC,0);
	want = cmdnum(argc,argv,'b',720,720);
	blksiz = cmdnum(argc,argv,'B',BLKSIZ,BIGBLK);
	if(blksiz == BIGBLK)	want /= 2;
	fover = cmdnum(argc,argv,'f',1,1);
	lover = cmdnum(argc,argv,'l',1,1);
	dolist(argc,argv,dofiles);
	dosorts(ngrp);
	dogroup(want);
	exit(0);
	return(0);	/* LINT */
}
static	char	*hx[] = {
	"=group [-options] [file(s)]",
	"*",
	"*    read the stdin or the named files for a list of files",
	"*    to group into units of -bNNNN size blocks (512 chars).",
	"*",
	"=",
	"-a        abort on any errors",
	"-bNNNN    set the group size to NNNN [720]",
	"-B        use 1024 char blocks, divide bNNNN by 2",
	"-fNNNN    over head blocks per file [1]",
	"-h        this message",
	"-H        this message plus copyright notice",
	"=NOTES",
	"720       maximum number of blocks for 360 K floppy",
	"1440      maximum number of blocks for 720 K floppy",
	"2400      maximum number of blocks for 1.2 M floppy",
	"=BUGS",
	"          links are counted as files.",
	"=",
	}	;
hint(ty)
NOSIGN	ty;
{
	prhint(hx,sizeof(hx)/sizeof(char *),ZERO,NULL);
	exit(ty);
	return(0);	/* LINT */
}
