/*DOSLIB*/
/*UNXLIB*/
/*
	11.14.88	added check for non-ascii files
    9.29.87 	no change to file times with rebuild
    9.18.87 	corrected error in "terror" that caused hang with
    			bad files.
*/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include	"ksysprot.h"
#include    <signal.h>
/**/
/**/
#define		WORKFILE	"/dlXXXXXX.tmp"
#define     CZ          '\032'
/**/
/*EXTERNAL*/
#ifdef	CAN_PROTO
extern int wrfold(FILE *);
extern int rebuild(int, char *);
extern int zero(char *);
extern int hint(int);
extern int listdo(char *, FUNCP);
extern void touch(char *);
#else
extern int wrfold();
extern int rebuild();
extern int zero();
extern int hint();
extern int listdo();
extern void touch();
#endif
/*GLOBAL*/
char		*wmode;
char		*rmode;
FILE		*ofp;
char		wfn[FNMSIZ];
char		*tmpdir;
char		*flist;
long        before;
long        after;
char        *sfn;
KENV        kenv;
FUNCP		func;
/*
**  dosunix
**  CR      LF
**  CRLF    LF
**  LF      LF
**  LFCR    LF
**
**  unixdos
**  LF      CRLF
**  LFCR    CRLF
**  CR      CRLF
**  CRLF    CRLF
*/
dosunix(fp,is)     /* convert dos-style to unix-style */
char	*is;
FILE    *fp;
{
    REG     int     cx;
    auto    int     notascii = 0;
	auto	int		ll = ZERO;
/**/
	if(kenv.flags1 & DA)	rebuild(0,is);
/**/
    while((cx = getc(fp)) != EOF)   {
/**/
    if(cx == CZ)    {
        prwho(" <removed ^Z> %s\n",is);
        }
    else
    if(cx == CR)    {
        putc(LF,ofp);
        cx = getc(fp);
        if(cx != LF && cx != EOF)   ungetc(cx,fp);
        ll = ZERO;
        }
    else
    if(cx == LF)    {
        putc(LF,ofp);
        cx = getc(fp);
        if(cx != CR && cx != EOF)   ungetc(cx,fp);
        ll = ZERO;
        }
	else
	if(kenv.folder && ll >= kenv.folder && isspace(cx))	{
		wrfold(ofp);
		ll = ZERO;
		}
    else    {
        putc(cx,ofp);
        if(notascii <= 0 && ( cx <= 0 || cx >= 127))	{
            notascii += 1;
            prwho(" <not ascii file> %s\n",is);
			rebuild(2,is);
			return(1);
            }
		ll += 1;
        }
    }
	if(kenv.flags1 & DA)	rebuild(1,is);
    return(ZERO);
}
unixdos(fp,is)
char	*is;
FILE    *fp;
{
    REG     int     cx;
	auto	int		ll = ZERO;
	auto	int		notascii = 0;
/**/
	if(kenv.flags1 & DA)	rebuild(0,is);
/**/
    while((cx = getc(fp)) != EOF)
    if(cx == CR)    {
        putc(CR,ofp);
        putc(LF,ofp);
/**/
        cx = getc(fp);
/**/
		if(cx == CR)	cx = getc(fp);
		else
		if(cx == LF)	;
		else
		if(cx == EOF)	;
		else			ungetc(cx,fp);
/**/
        ll = ZERO;	
        }
    else
    if(cx == LF)    {
        putc(CR,ofp);
        putc(LF,ofp);
        cx = getc(fp);
        if(cx != CR && cx != EOF)   ungetc(cx,fp);
        ll = ZERO;
        }
	else
	if(kenv.folder && ll >= kenv.folder && isspace(cx))	{
		wrfold(ofp);
		ll = ZERO;
		}
    else    {
		putc(cx,ofp);
        if(notascii <= 0 && ( cx <= 0 || cx >= 127))	{
            notascii += 1;
            prwho(" <not ascii file> %s\n",is);
			rebuild(2,is);
			return(1);
            }
		ll += 1;
		}
/**/
    if(kenv.flags1 & DA)	rebuild(1,is);
    return(ZERO);
}
wrfold(ofp)
FILE	*ofp;
{
	if(kenv.buffer & DA)	putc('\\',ofp);
	if(func == (FUNCP) dosunix)		putc(LF,ofp);
	else
	if(func == (FUNCP) unixdos)		{putc(CR,ofp);putc(LF,ofp);}
	if(kenv.buffer & DB)	putc('>',ofp);
	return(ZERO);
}
rebuild(ty,is)
char	*is;
int		ty;
{
	static	long	end_siz;
	static	long	beg_siz;
	static	char	*ob = NULL;
    if(ty == 0) {
		if(!isnull(wfn))	unlink(wfn);
		beg_siz = filesize(is);
		tmpdir = (int) (tmpdir = kgetenv("TMPDIR")) ? tmpdir : "." ;
		strcpy(wfn,tmpdir);
		strcat(wfn,WORKFILE);
        maketemp(wfn);
		ofp = tefopen(wfn,wmode);
#ifdef	SYSV
		ob = ksetvbuf(ofp,ob,_IOFBF,kenv.blockd);
#endif	/*SYSV*/
        return(0);
        }
    else
    if(ty == 1) {
		ofp = xfclose(ofp);
		end_siz = filesize(wfn);
		if(end_siz == 0L)		{
			if(kenv.flags2 & DA)		gut(is);
			zero(is);
			if(kenv.flags2 & DA)		sut(is);
			}
		else
		if(end_siz != beg_siz)	{
			if(kenv.flags2 & DA)		gut(is);
			if(end_siz == 0L)			zero(is);
			else
			if(linkorcopy(wfn,is))		exit(FUBAR);
			if(kenv.flags2 & DA)		sut(is);
			if(kenv.report && end_siz >= 1L)	{
				printf("%ld -> %ld %s\n",beg_siz,end_siz,is);
				}
		}
		else	{
			if(kenv.report)	{
				printf("<no change> %s\n",is);
				}
			}
		unlink(wfn);
        return(0);
        }
	else
	if(ty == 2)	{
		xfclose(ofp);
		ob = free_if(ob);
		unlink(wfn);
		}
	else	{
		dump("rebuild");
		exit(FUBAR);
		}
}
zero(is)
char	*is;
{
	auto	FILE	*fp = efopen(is,wmode);
	fp = xfclose(fp);
	if(kenv.report)	{
		prwho("<zero length file> '%s'\n",is);
		}
	return(ZERO);
}
hint(ty)
int		ty;
{
static	char	*hx[] = {
"=udl [-options] [file(s)]",
#ifdef	SYSV
"-Bnn     blocking factor [16]",
#endif	/*SYSV*/
"-d       rewrite in dos style",
"-f list  process file(s) given in list",
"-f -     process file(s) taken from stdin",
"m0       do not maintain modification times",
"m1       maintain modification times [default]",
"-r       rewrite file [on]",
"-Tn      set termination style with folding",
"-T1      \\?",
"-T2      ?>",
"-T3      \\?>",
"         ? is LF or CRLF as appropriate",
"-u       rewrite in unix style",
"-v       report [on]",
"-wnn     fold lines on first space after nn [56] characters",
"*        turns off rebuild function",
"=",
"~",
"=EXAMPLES",
"*",
"*   udl -u biblbibl.ked",
"*       rewrite the file biblbibl.ked with unix-style line",
"*       termination",
"*",
"*   udl -u -r0 biblbibl.ked",
"*       write the file biblbibl.ked to the stdout with unix-style",
"*       line termination",
"*",
"*   udl -F -u -r0 biblbibl.ked",
"*       as above with folding after 56 characters",
"*",
"=",
"~",
"=BUGS",
"*",
"*   tabs count as one character for folding",
"*",
"*   escape sequences will distort the folding count",
"*",
"*   use on a binary file will almost certainly trash the file",
"*",
"=",
}	;
	prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
	exit(ty);
}
void
terror(ty)
int   ty;
{
    if((!isnull(wfn)) && unlink(wfn))   {
        prterr("%s",wfn);
        }
    exit(ty);
}
main(argc,argv)
int     argc;
char    *argv[];
{
	extern	int	udl();
	kenv.dosdos = isdos();
	disnme(kenv.pname = "udl");
	exit(cmdxrc(argc,argv,udl,"udl.xrc"));
}
udl(argc,argv)
int	argc;
char	*argv[];
{
	if(kenv.dosdos)	cmdxpd(argc,argv);
	else			telluser(kenv.pname);
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/**/
	ofp = stdout;
/**/
    if(cmdnum(argc,argv,'W',0,1))   {
        kenv.leisur = DA | DB;
        whoru(ofp);
        exit(0);
        }
/**/
#ifdef	SYSV
	kenv.blockd = cmdnum(argc,argv,'B',16,16) * bufsiz();
#endif	/*SYSV*/
/**/
    kenv.flags1 = cmdnum(argc,argv,'r',1,0);
    kenv.flags2 = cmdnum(argc,argv,'m',DA,DA);
    kenv.report = cmdnum(argc,argv,'v',1,DA);
    kenv.diagno = cmdnum(argc,argv,'D',0,1);
    if(kenv.dosdos)	func = (FUNCP) unixdos;
    	else		func = (FUNCP) dosunix;
    if(cmdnum(argc,argv,'d',0,1))   func = (FUNCP) unixdos;
    if(cmdnum(argc,argv,'u',0,1))   func = (FUNCP) dosunix;
    if(cmdnum(argc,argv,'h',0,1))   {
		if(isatty(1))	{
			kenv.leisur = DA | DB;
			whoru(stdout);
			query(stdout);
			}
		exit(hint(0));
		}
	kenv.folder = cmdnum(argc,argv,'w',0,56);
	if(kenv.folder)	kenv.flags1 = ZERO;
	kenv.buffer = cmdnum(argc,argv,'T',0,DA);
    signal(SIGINT,terror);
	setsig((FUNCP) terror);
/**/
	if((int)(flist = cmdstr(argc,argv,'f',NULL)))	flist = blkrd(flist);
	else
	flist = cmdlist(argc,argv,ZERO,NULL);
/**/
	if(kenv.dosdos)	{
		wmode = "wb";
		rmode = "rb";
		}
	else	{
		wmode = "w";
		rmode = "r";
		}
/**/
	listdo(flist,func);
/**/
    unlink(wfn);
    exit(0);
}
listdo(is,func)
char	*is;
FUNCP	func;
{
	auto	char	ws[FNMSIZ];
	auto	char	*isx = is;
	auto	FILE	*fp;
	auto	int		nf = ZERO;
	static	char	*ib = NULL;
	strxty(is,CR,ZERO);
	strxty(is,LF,' ');
/**/
	while((int)(isx = xgnc(ws,ws+FNMSIZ-1,isx,' ')))	{
/**/
		nf += 1;
		if(!(int) (fp = efopen(ws,rmode)))	continue;
#ifdef	SYSV
		ib = ksetvbuf(fp,ib,_IOFBF,kenv.blockd);
#endif	/*SYSV*/
		(*func)(fp,ws);
		xfclose(fp);
/**/
		}
/**/
	if(nf == ZERO)	{
		kenv.flags1 = ZERO;
		(*func)(stdin,NULL);
		}
/**/
	ib = free_if(ib);
/**/
	return(nf);
}
void
touch(is)	/* make zero length file */
char	*is;
{
	auto	FILE	*fp;
	fp = efopen(is,"a");
	if(fp)	fp = xfclose(fp);
	return;
}
